/*--------------------------------------------------------------------------*/
static FILE_BUF domfb;
static byte fs_entry;
static byte fm_entry;
int ex,ey;
int oldx;
int oldy;
int oldobj;
TCHSTS tsts;
/*--------------------------------------------------------------------------*/
void PollEvent() // Written for 1600 by O'Razoff.
{
  if (LibTchScanSub(&tsts))
  {
    switch(tsts.act)
    {
      case IMUL_ACT_MK: // First touch
      case IMUL_ACT_MV: // Move touch
	oldx=tsts.x;
	oldy=tsts.y;
	oldobj=((tsts.obj>>8)==0x9f); // Touch object
	break;
      case IMUL_ACT_BK: // Release
	tsts.x=0;
	tsts.y=0;
	oldobj=0;
    }
  }
  else
  {
    tsts.act=0;
    if (oldobj)
    {
      tsts.x=oldx;
      tsts.y=oldy;
    }
    else
    {
      tsts.x=0;
      tsts.y=0;
    }
  }
}

/*--------------------------------------------------------------------------*/
bool AreaIsTouched(int xmin,int ymin,int xmax,int ymax) // Written for 1600 by O'Razoff.
{
  bool rc;
  rc=(((tsts.x>xmin)&&(tsts.x<xmax))&&((tsts.y>ymin)&&(tsts.y<ymax)));
  return rc;
}
/*--------------------------------------------------------------------------*/
void PushButton(int a,int b,int c,int d) // Written for 1600 by O'Razoff.
{
  LibSKeyRevSub(a,b,c,d,IB_GDS_KEYREV,IB_GDS_KREVP1);
  LibWait(IB_250MWAIT);
  LibSKeyRevSub(a,b,c,d,IB_GDS_KEYREV,IB_GDS_KREVP1);
  LibWait(IB_250MWAIT);
}
/*--------------------------------------------------------------------------*/
bool ButtonIsTouched(int a,int b,int c,int d) // Written for 1600 by O'Razoff.
{
  bool rc;
  rc=AreaIsTouched(a,b,c,d);
  if (rc) PushButton(a,b,c,d);
  return rc;
}
/*--------------------------------------------------------------------------*/
bool EscIsTouched() // Written for 1600 by O'Razoff.
{
  return (ButtonIsTouched(ex-1,ey+1,ex+5,ey+7)||AreaIsTouched(137,160,160,174));
}
/*--------------------------------------------------------------------------*/
void GetEvent() // Written for 1600 by O'Razoff.
{
  keypush=getleverpush();
  if (!keypush)
  {
    PollEvent();
    if (ButtonIsTouched(23,160,46,190))
/* Button Left */
      keypush=6;
    if (ButtonIsTouched(46,160,69,190))
/* Button Down */
      keypush=3;
    if (ButtonIsTouched(69,160,91,190))
/* Button Push */
      keypush=2;
    if (ButtonIsTouched(91,160,114,190))
/* Button UP */
      keypush=1;
    if (ButtonIsTouched(114,160,137,190))
/* Button Right */
      keypush=7;
  }
  if (keypush)
  {
    tsts.x=0;
    tsts.y=0;
  }
}
/*--------------------------------------------------------------------------*/
void TchWait() // Written for 1600 by O'Razoff.
{
  if (tsts.act==IMUL_ACT_MK) tsts.act=0;
  while(tsts.act!=IMUL_ACT_MK)
  {
    LibTchWait(&tsts);
  }
  oldobj=0;
}
/*--------------------------------------------------------------------------*/
void DrawButton(int a,int b,int c,int d,char *text) // Written for 1600 by O'Razoff.
{
  LibGdsClr(a,b,c,d);
  LibGdsBox(a,b,c-1,d-1);
  LibGdsLine(a+1,d,c,d);
  LibGdsLine(c,b+1,c,d);
  if (text)
  LibStringDsp((byte *)text,a+2,b+2,160,IB_PFONT1);
}
/*--------------------------------------------------------------------------*/
void CloseButton(int a,int b,int c,int d) // Written for 1600 by O'Razoff.
{
  DrawButton(a,b,c,d,"Close");
  LibPutDisp();
  while(1)
  {
    TchWait();
    if (ButtonIsTouched(a,b,c,d)||EscIsTouched()||(getleverpush()==2))
    {
      LibCloseWindow();
      LibPutDisp();
      tsts.x=0;
      tsts.y=0;
      return;
    }
  }
}
/*--------------------------------------------------------------------------*/
void CloseButtonC(int y) // Written for 1600 by O'Razoff.
{
  int len,x;
  len=LibGetProStrSize(IB_PFONT1,(byte *)"Close")+4;
  x=(160-len)/2;
  CloseButton(x,y,x+len-1,y+11);
}
/*--------------------------------------------------------------------------*/
void OpenWindow(int a,int b,int c,int d,char *text) // Written for 1600 by O'Razoff.
{
  LibOpenWindowS(1,a,b,c,d);
  if (text)
  LibStringDsp((byte *)text,a+(c-LibGetProStrSize(IB_PFONT1,(byte *)text))/2,b+3,160,IB_PFONT1);
  ex=a+c-10;
  ey=b+2;
  LibStringDsp((byte *)"x",ex,ey,160,IB_PFONT1);
  LibGdsReverse(a+2,b+2,a+c-4,b+11);
}
/*--------------------------------------------------------------------------*/
void PrintInt(int a,int x,int y) // Written for 1600 by O'Razoff.
{
char string[4];
  sprintf(string,"%3d",a);
  string[3]=0;
  LibStringDsp((byte *)string,x,y,160,IB_PFONT1);
}
/*--------------------------------------------------------------------------*/
void PrintXY(char *s, int x, int y)
{
  if (s) LibStringDsp((byte *)s,x,y,160,IB_PFONT1);
}
/*--------------------------------------------------------------------------*/
void Alert(char *text) // Written for 1600 by O'Razoff.
{
  int len=0;
  int xmin,xsize;
  int ymin,ysize;
  int src=0;
  int dst=0;
  int space=0;
  char s[32];
  char curc;
  ysize=strlen(text);
  ymin=(int)text;
  do {
    xmin=(int)strchr((const char *)ymin,13);
    if (xmin)
    {
      xsize=xmin-ymin;
      ymin=xmin+1;
      if (len<xsize) len=xsize;
    }
  } while (xmin);
  if (!len) len=ysize;
  xsize=len*5+10;
  if (xsize>160) xsize=160;
    xmin=(160-xsize)/2;
  ysize=(ysize/25+5)*12;
  if (ysize>160) ysize=160;
    ymin=(160-ysize)/2;
  OpenWindow(xmin,ymin,xsize,ysize,"PV Runner");
  xmin+=5;
  ysize=ysize+ymin-16;
  ymin+=24;
  do {
    curc=text[src];
    src++;
    s[dst]=curc;
    dst++;
    if (!curc)
    {
      PrintXY(s,xmin,ymin);
    }
    if (curc==13)
    {
      s[dst-1]=0;
      PrintXY(s,xmin,ymin);
      dst=0;
      space=0;
      ymin+=12;
    }
    if (curc==32)
    {
      space=dst-1;
    }
    if (dst>29)
    {
      if (!space) space=dst-1;
      s[space]=0;
      src=src-(dst-space);
      PrintXY(s,xmin,ymin);
      dst=0;
      space=0;
      ymin+=12;
    }
  } while (curc);
  CloseButtonC(ysize);
}
/*--------------------------------------------------------------------------*/
void LibErrorDisp(word err_code) // Written for 1600 by O'Razoff.
{
//LibPutMsgDlg((byte *)"\rLoad/Save error.\r\r");
  Alert("Load/Save error.");
}
/*--------------------------------------------------------------------------*/
#define BUZZCONTROL ((byte*)0xA44C0020) // Buzzer control register
void outpsound(int c) // Written for 1600 by O'Razoff.
{
  if (c)
  {
    *BUZZCONTROL=(*BUZZCONTROL) | 3; // Buzz ON
  }
  else
  {
    *BUZZCONTROL=(*BUZZCONTROL) & 0xfc; // Buzz OFF
  }
}

/*--------------------------------------------------------------------------*/
