/*******************************************************************************
 Programname:	LodeRuner
      Author:	Vladius
	Date:	11.12.2002
********************************************************************************
Programhistory:

Version 2.1 for PV-S1600 by O'Razoff & Xorbis 14.02.2006
*******************************************************************************/

#include "pv-s1600.h"
#include "lode.h"
#include "pv-s1600.c"
#define DATAFILENAME "Runner"
#define MAXLEVEL 80
struct {
  int lives;
  int level;
  bool sound;
} SaveData;
/*--------------------------------------------------------------------------*/
void main()
{
  int i;
  srand(GetSeed());
  LibInitDisp();
  LibTchInit();
  LibTchStackClr();
  LibTchStackPush(0);
  LibTchStackPush(TchHardIcon);
  LibTchStackPush(TchAllDsp);
  Intro();
  BeginNew();
  while (loop!=20) // Main cycle
  {
    skorost=skorost_change+20;
    if (loop==WIN) // 먣
    {
      if (SaveData.sound==1)
      {
	note("C3", 20000, 10);
	note("E3", 20000, 10);
	note("G3", 20000, 10);
	note("D3", 20000, 10);
	note("F3", 20000, 10);
	note("A3", 20000, 10);
	note("E3", 20000, 10);
	note("G3", 20000, 10);
	note("B3", 20000, 10);
	note("F3", 20000, 10);
	note("A3", 20000, 10);
	note("C4", 40000, 10);
      }
      else
      LibWait(IB_1SWAIT);
      if (level>=MAXLEVEL)
      {
	Alert("Congratulations.\r   You win.");
	lives=0;
	loop=FAIL;
      }
      else
      BeginNew();
    }
    if (loop==FAIL) //    । ࠧ
    {
      if (SaveData.sound==1)
      {
	note("C3", 6000, 10);
	note("B2", 6000, 10);
	note("A2", 6000, 10);
	note("G2", 6000, 10);
	note("F2", 6000, 10);
	note("E2", 6000, 10);
	note("D2", 12000, 10);
	note("C2", 24000, 10);
      }
      else
      LibWait(IB_1SWAIT);
      if (lives<=0) //   3 ࠧ
      {
	level=1;
	lives=3;
	Intro();
      }
      BeginNew();
    }
    if (loop==NEW) //  ஢  .
      BeginNew();
    GetEvent();
    if (AreaIsTouched(137,160,160,190))
    {
      // "Esc"/"Menu" (right)
      lev=level+1;
      if (lev>MAXLEVEL) lev=MAXLEVEL;
      Menu();
    }
    if (keypush==6)
    {
      //LEFT, "Menu"
      naprav=-2;
      tsts.x=1;
      tsts.y=x2-8;
    }
    if (keypush==7)
    {
      //RIGHT, "Quick"
      naprav=2;
      tsts.x=159;
      tsts.y=x2-8;
    }
    if (keypush==1)
    {
      //UP, "Sync"
      vert=-2;
      tsts.x=x1-7;
      tsts.y=1;
    }
    if (keypush==3)
    {
      //DOWN, "Sched"
      vert=2;
      tsts.x=x1-7;
      tsts.y=159;
    }
    if (AreaIsTouched(0,0,160,160))
    {
      skorost=skorost_change;
      tsts.x=tsts.x+8;
      tsts.y=tsts.y+8;
      if (tsts.x/8<x1/8)
      {
	naprav=-2;
      }
      if (tsts.y/8<x2/8)
      {
	vert=-2;
      }
      if (tsts.x/8>x1/8)
      {
	naprav=2;
      }
      if (tsts.y/8>x2/8)
      {
	vert=2;
      }
      Dvijenie();
    }
    Padenie();
    if (zamed==0)
    {
      Dvijenie_lox();
      zamed=1;
    }
    else
    {
      Padenie_lox();
      zamed=0;
    }
    Draw_Yama();
/* প */
    for (i=0; i<(skorost_change); i++)
    {
      LibPutDisp();
    }
  } // Main cycle end
  LibJumpMenu();
}

/*--------------------------------------------------------------------------*/
int BeginNew()
{
  int i;
  int j;
  Start();
  tsts.x=1;
  tsts.y=1;
  i=0;
  j=1;
  while (i!=1)
  {
    LibWait(IB_125MWAIT);
    GetEvent();
    if ((j==0)||(j==4))
    Beg_Clear();	     /* ࠥ/ */
    if (AreaIsTouched(0,0,160,190)||(keypush!=0))
    {
      i=1;
      if (j>=4)
      Beg_Clear();
    }
    j++;
    j&=7;
  }
}

/*--------------------------------------------------------------------------*/
void LoadGame()
{
  loadData();
  if (((SaveData.level>0)&&(SaveData.level<=MAXLEVEL))
    &&((SaveData.lives>0)&&(SaveData.lives<=MAXLEVEL)))
  {
    lives=SaveData.lives;
    level=SaveData.level;
  }
}
/*--------------------------------------------------------------------------*/
void Menu()
{
  OpenWindow(10,10,140,140,"Game setup");
  DrawButton( 20, 34,139, 45," Resume current level");
  DrawButton( 20, 50,139, 61," Restart current level");
  DrawButton( 20, 66,139, 77," Go to level:");
  DrawButton( 20, 82, 43, 93," <<");
  DrawButton( 52, 82, 75, 93," <");
  DrawButton( 84, 82,107, 93,"  >");
  DrawButton(116, 82,139, 93," >>");
  PrintXY("Game speed",20,100);
  DrawButton( 80, 98, 99,109," <");
  DrawButton(120, 98,139,109," >");
  DrawButton( 20,114, 78,125," Save game");
  DrawButton( 81,114,139,125," Load game");
  DrawButton( 81,130,139,141," Exit game");
  while(1)
  {
    PrintInt(lev,80,68);
    PrintInt(40-skorost_change,100,100);
    if (SaveData.sound==1)
    DrawButton( 20,130, 78,141," Sound on ");
    else
    DrawButton( 20,130, 78,141," Sound off");
    LibPutDisp();
    TchWait();
    if (AreaIsTouched( 20, 34,139, 45)||EscIsTouched())
      break;
    else
    if (ButtonIsTouched( 20, 50,139, 61))
    {
      lives=lives-1;
      loop=FAIL;
      break;
    }
    else
    if (ButtonIsTouched( 20, 66,139, 77))
    {
      level=lev;
      lives=1;
      loop=NEW;
      break;
    }
    else
    if (ButtonIsTouched( 20, 82, 43, 93))
    {
      lev-=10;
      if (lev<1)
      lev=1;
    }
    else
    if (ButtonIsTouched( 52, 82, 75, 93))
    {
      if (lev>1)
      lev--;
    }
    else
    if (ButtonIsTouched( 84, 82,107, 93))
    {
      if (lev<MAXLEVEL)
      lev++;
    }
    else
    if (ButtonIsTouched(116, 82,139, 93))
    {
      lev+=10;
      if (lev>MAXLEVEL)
      lev=MAXLEVEL;
    }
    else
    if (ButtonIsTouched( 80, 98, 99,109))
    {
      if (skorost_change<40)
      skorost_change+=2;
    }
    else
    if (ButtonIsTouched(120, 98,139,109))
    {
      if (skorost_change>1)
      skorost_change-=2;
    }
    else
    if (ButtonIsTouched( 20,114, 78,125))
    {
      saveSettings(lives,level);
    }
    else
    if (ButtonIsTouched( 81,114,139,125))
    {
      LoadGame();
      loop=NEW;
      break;
    }
    else
    if (ButtonIsTouched( 20,130, 78,141))
    {
      if (SaveData.sound==1)
      SaveData.sound=0;
      else
      SaveData.sound=1;
    }
    else
    if (ButtonIsTouched( 81,130,139,141))
    {
      LibJumpMenu();
    }
  }
  LibCloseWindow();
}

/*--------------------------------------------------------------------------*/
void About()
{
  OpenWindow(0,10,160,140,"About PV Runner");
  PrintXY("Originally written for PV-S450",10, 34);
  PrintXY("by Vladius in 2002. (V 1.52)",  10, 46);
  PrintXY("Porting to PV-S1600 and new",   10, 70);
  PrintXY("interface by O'Razoff in 2006.",10, 82);
  PrintXY("Additional levels, sound and",  10,106);
  PrintXY("algorithm changes by Xorbis.  ",10,118);
  CloseButtonC(134);
}
/*--------------------------------------------------------------------------*/
void Help()
{
  OpenWindow(0,10,160,140,"PV Runner help");
  LibStringDsp((byte *)"Controls are:", 10,34,2000, IB_PFONT3);
  LibStringDsp((byte *)"(Left)  [Menu]  - Left",    2, 50,160, IB_CG57FONT);
  LibStringDsp((byte *)"(Down)  [Sched] - Down",    2, 62,160, IB_CG57FONT);
  LibStringDsp((byte *)"(Push)  [Cont]  - Dig/Stop",2, 74,160, IB_CG57FONT);
  LibStringDsp((byte *)"(Up)    [Sync]  - Up",      2, 86,160, IB_CG57FONT);
  LibStringDsp((byte *)"(Right) [Quick] - Right",   2, 98,160, IB_CG57FONT);
  LibStringDsp((byte *)"[Esc]/[Menu]    - Options", 2,110,160, IB_CG57FONT);
  CloseButtonC(134);
}
/*--------------------------------------------------------------------------*/
void Intro()
{
  int i=0;
  int l=0;
  LibClrDisp();
  LibPutGraph (30, 10, title);
  PrintXY("Version 2.1",55,37);
  DrawButton(45, 53,114, 64," New game");
  DrawButton(45, 69,114, 80," Load game");
  DrawButton(45, 85,114, 96," Help");
  DrawButton(45,101,114,112," About");
  DrawButton(45,117,114,128," Exit");
  LibPutDisp();
  while (1)
  {
    TchWait();
    if (ButtonIsTouched(45, 53,114, 64))
      break;
    if (ButtonIsTouched(45, 69,114, 80))
    {
      LoadGame();
      break;
    }
    if (ButtonIsTouched(45, 85,114, 96))
      Help();
    if (ButtonIsTouched(45,101,114,112))
      About();
    if (ButtonIsTouched(45,117,114,128))
      LibJumpMenu();
  }
}

/*--------------------------------------------------------------------------*/
void Padenie()
{
  int index1;
/* 騪  */
  if ((k[(x1+1)/8][(x2+2)/8]==-2)
  &&(k[(x1+6)/8][(x2+2)/8]==-2))
  {
    k[x1/8][(x2+2)/8]=0;
    Draw_box(x1/8,(x2+2)/8);
    yashikov=yashikov-1;
    PrintInt(yashikov,136,0);
    LibPutDisp();
    if (SaveData.sound==1)
    {
      note("C4", 1000, 10);
    }
    if (yashikov==0)
    {
      Add_exit();
      LibPutDisp();
      if (SaveData.sound==1)
      {
	note("C3", 20000, 10);
	note("E3", 20000, 10);
	note("G3", 20000, 10);
	note("C4", 40000, 10);
	note("G3", 20000, 10);
	note("C4", 40000, 10);
      }
      else
      LibWait(IB_500MWAIT);
    }
  }
/*      */
  if ((k[(x1)/8][(x2)/8]==1)
  &&(k[(x1+7)/8][(x2)/8]==1)
  &&((int)((x2)/8)==(int)((x2+7)/8))
  &&(k[(x1)/8][(x2+7)/8]==1)
  &&(k[(x1+7)/8][(x2+7)/8]==1)
  &&(kanat==0))
  {
    padla=0;
    kanat=1;
    Beg_Clear();
    telo=5;
    Beg_Runer();
  }
  if ((k[(x1)/8][(x2+2)/8]==1)
  &&(k[(x1+7)/8][(x2+2)/8]==1)
  &&((int)((x2+2)/8)==(int)((x2+7)/8))
  &&(k[(x1)/8][(x2+7)/8]==1)
  &&(k[(x1+7)/8][(x2+7)/8]==1)
  &&(padla==1)
  &&(kanat==0))
  {
    oldnap=naprav;
    naprav=0;
  }
/* 砫  */
  if ((k[(x1)/8][(x2+8)/8]<=1)
  &&(k[(x1+7)/8][(x2+8)/8]<=1)
  &&(k[(x1)/8][(x2+1)/8]<=1)
  &&(k[(x1+7)/8][(x2+1)/8]<=1)
  &&(kanat==0))
  {
    padla=1;
    vert=2;
    Beg_Clear();
    telo=4;
    x2=x2+vert;
    Beg_Runer();
  }
/* ⥫ */
  if (((k[(x1)/8][x2/8+1]>1)
  ||(k[(x1+7)/8][x2/8+1]>1))
  &&(padla==1))
  {
    if (((k[(x1)/8][x2/8+1]==2)
    ||(k[(x1+7)/8][x2/8+1]==2))
    &&(vert==2))
    {
      oldnap=naprav;
      naprav=0;
    }
    padla=0;
    Beg_Clear();
    telo=0;
    Beg_Runer();
  }
/*  */
  if (naprav!=0)
  oldnap=naprav;
  index1=(x1-2+(abs(abs(oldnap)+oldnap)*10/4))/8;
  if ((keypush==2)
  &&(k[index1][x2/8+1]==5)
  &&((k[index1][(x2)/8]==0)
  ||(k[index1][(x2)/8]==-1)
  ||(k[index1][(x2)/8]==-3))
  &&(padla!=1)
  &&(lest!=1))
  {
    k[index1][(x2+8)/8]=-1;
    Get_Yama();
    if (SaveData.sound==1)
    {
      note("A2", 3000, 10);
    }
    Beg_Clear();
    x1=(index1*8/8-abs(oldnap)/oldnap)*8;
    Beg_Runer();
    index1=(x2+7+abs(abs(vert)+vert)/4)/8;
    if ((((k[(x1+1)/8][index1]==2)
    &&(k[(x1+6)/8][index1]==2))
    ||((k[(x1+1)/8][(x2)/8]==2)
    &&(k[(x1+6)/8][(x2)/8]==2)))
    &&(k[(x1+1)/8][index1]<5))
    {
      lest=1;
    }
  }
}

/*--------------------------------------------------------------------------*/
void Dvijenie()
{
  int index1;
/*  */
  if (((tsts.y/8-x2/8)>abs(x1/8-tsts.x/8))
  &&(k[(x1)/8][(x2+8)/8]<=1)
  &&(k[(x1+7)/8][(x2+8)/8]<=1)
  &&(kanat==1)
  &&(x1/8==(x1+7)/8))
  {
    kanat=0;
    padla=1;
    vert=2;
    Beg_Clear();
    telo=5;
    x2=x2+vert;
    Beg_Runer();
  }
  index1=(x1-2+abs(abs(naprav)+naprav)*10/4)/8;
  if ((k[index1][x2/8]<5)
  &&(k[index1][(x2+7)/8]<5)
  && ((((int)((x2)/8)==(int)((x2+7)/8))
  &&(k[(x1)/8][(x2)/8]==1)
  &&(k[(x1)/8][(x2+7)/8]==1))
  ||(((int)((x2)/8)==(int)((x2+7)/8))
  &&(k[(x1+7)/8][(x2)/8]==1)
  &&(k[(x1+7)/8][(x2+7)/8]==1))))
  {
    if (kanat==0)
    {
      kanat=1;
      Beg_Clear();
      telo=5;
      x1=x1+naprav;
      Beg_Runer();
    }
    else
    {
      Beg_Clear();
      x1=x1+naprav;
      Beg_Runer();
    }
  }
/* ⥭ ᫥  ࠢ */
  if ((k[index1][x2/8]<5)
  &&(k[index1][(x2+7)/8]<5)
  &&(padla!=1)&&(lest!=1)&&(kanat!=1))
  {
    Beg_Clear();
    x1=x1+naprav;
    Beg_Runer();
  }
/*⭨*/
  if (((abs(x2/8-tsts.y/8)>=abs(x1/8-tsts.x/8))
  ||((x2>tsts.y)
  &&(k[x1/8][x2/8]<=1)
  &&(k[(x1+7)/8][x2/8]<=1)))
  &&(x1/8==(x1+7)/8))
  {
    index1=(x2+7+abs(abs(vert)+vert)/4)/8;
    if ((((k[(x1+1)/8][index1]==2)
    &&(k[(x1+6)/8][index1]==2))
    ||((k[(x1+1)/8][(x2)/8]==2)
    &&(k[(x1+6)/8][(x2)/8]==2)))
    &&(k[(x1+1)/8][(x2-1+abs(abs(vert)+vert)*9/4)/8]<5))
    {
      lest=1;
      Beg_Clear();
      x2=x2+vert;
      Beg_Runer();
    }
  }
  if (abs(x2-tsts.y)<abs(x1-tsts.x)) lest=0;
  if ((k[(x1)/8][(x2+7)/8]!=1)
  &&(k[(x1+7)/8][(x2+7)/8]!=1)
  &&(kanat==1))
  {
    kanat=0;
    Beg_Clear();
    telo=0;
    Beg_Runer();
  }
  if (x2/8<=1)
  {
    level=level+1;
    lives=lives+1;
    loop=WIN;
  }
}

/*--------------------------------------------------------------------------*/
void Padenie_lox()
{
  int i;
  int j;
  for (i=0; i<loxov; i++)
  {
    if (xl3[i]!=0)
    {
/*  騪 */
      if ((k[(xl1[i]+1)/8][xl2[i]/8]==-2)
      &&(k[(xl1[i]+6)/8][xl2[i]/8]==-2)
      &&(yashik_l[i]==0)
      &&(rand()%3)==1)
      {
	k[xl1[i]/8][xl2[i]/8]=0;
	Draw_box(xl1[i]/8,xl2[i]/8);
	yashik_l[i]=(rand()%200)+1;
	LibPutDisp();
      }
      if (yashik_l[i]>0)
      {
	yashik_l[i]=yashik_l[i]-1;
	if (yashik_l[i]==0)
	if ((padla_l[i]==0)
	&&(bashka_l[i]==0)
	&&(k[(xl1[i])/8][xl2[i]/8]==0)
	&&(k[(xl1[i]+7)/8][xl2[i]/8]==0))
	{
	  k[xl1[i]/8][xl2[i]/8]=-2;
	  Draw_box(xl1[i]/8,xl2[i]/8);
	}
	else yashik_l[i]=30;
      }
/*    */
      if (((int)((xl2[i])/8)==(int)((xl2[i]+7)/8))
      &&(k[(xl1[i])/8][(xl2[i])/8]==1)
      &&(k[(xl1[i]+7)/8][(xl2[i])/8]==1)
      &&(k[(xl1[i])/8][(xl2[i]+7)/8]==1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+7)/8]==1)
      &&(kanat_l[i]==0))
      {
	padla_l[i]=0;
	kanat_l[i]=1;
	Beg_Clear_lox(i);
	telo_l[i]=5;
	Beg_Runer_lox(i);
	check_nap[i]=1;
      }

/*  */
      if (((xl1[i]/8==(xl1[i]+7)/8))
      &&(k[(xl1[i])/8][(xl2[i]+8)/8]<=1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+8)/8]<=1)
      &&(k[(xl1[i])/8][(xl2[i]+1)/8]<=1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+1)/8]<=1)
      &&(kanat_l[i]==0)
      &&(yama_l[i]==0))
      {
	padla_l[i]=1;
	for (j=0; j<loxov; j++)
	{
	  if ((i!=j)
	  &&(abs(xl1[i]-xl1[j])<8)
	  &&(abs(xl2[i]-xl2[j])<=8)
	  &&(axl1[j]!=bxl1[j])
	  &&(axl2[j]!=bxl2[j])
	  &&(xl2[i]<xl2[j]))
	  {
	    padla_l[i]=0;
	    bashka_l[i]=1;
	    j=8;
	  }
	  else bashka_l[i]=0;
	}
	if (padla_l[i]==1)
	{
	  vert_l[i]=2;
	  Beg_Clear_lox(i);
	  telo_l[i]=4;
	  xl2[i]=xl2[i]+vert_l[i];
	  Beg_Runer_lox(i);
	}
      }
/*  */
      if ((k[(xl1[i])/8][(xl2[i])/8]==-1)
      &&(k[(xl1[i]+7)/8][(xl2[i])/8]==-1)
      &&(k[(xl1[i])/8][(xl2[i]+7)/8]==-1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+7)/8]==-1)
      &&((xl2[i]/8)==((xl2[i]+7)/8))
      &&(padla_l[i]==1))
      {
	padla_l[i]=0;
	if ((yama_l[i]==0)&&(yashik_l[i]!=0))
	{
	  if (k[xl1[i]/8][xl2[i]/8-1]==0)
	  {
	    k[xl1[i]/8][xl2[i]/8-1]=-2;
	    Draw_box(xl1[i]/8,xl2[i]/8-1);
	    yashik_l[i]=0;
	  }
	}
	yama_l[i]=yama_l[i]+1;
	k[(xl1[i])/8][(xl2[i])/8]=7;
	Beg_Clear_lox(i);
	telo_l[i]=4;
	Beg_Runer_lox(i);
      }
      if ((k[(xl1[i])/8][(xl2[i])/8]==7)&&(yama_l[i]>0))
      {
	yama_l[i]=yama_l[i]+1;
	if (yama_l[i]==30)
	{
	  yama_l[i]=0;
	  k[(xl1[i])/8][(xl2[i])/8]=-1;
	  Beg_Clear_lox(i);
	  telo_l[i]=0;
	  xl1[i]=xl1[i]+naprav_l[i];
	  xl2[i]=xl2[i]-8;
	  Beg_Runer_lox(i);
	}
      }
/* ⥫ */
      if (((k[(xl1[i])/8][xl2[i]/8+1]>1)
      ||(k[(xl1[i]+7)/8][xl2[i]/8+1]>1))
      &&(padla_l[i]==1)
      &&(yama_l[i]==0))
      {
	padla_l[i]=0;
	Beg_Clear_lox(i);
	telo_l[i]=0;
	Beg_Runer_lox(i);
	check_nap[i]=1;
      }
    }
  }
}

/*--------------------------------------------------------------------------*/
void Dvijenie_lox()
{
  int i;
  int j;
  int index1;
  int index2;
  for (i=0; i<loxov; i++)
  {
    bxl1[i]=axl1[i];
    bxl2[i]=axl2[i];
    axl1[i]=xl1[i];
    axl2[i]=xl2[i];
    if (xl3[i]!=0)
    {
      if ((x2/8<=xl2[i]/8)&&(lest_l[i]==0))
      {
	vert_l[i]=-2;
      }
      if ((x2/8>xl2[i]/8)&&(lest_l[i]==0))
      {
	vert_l[i]=2;
      }
      if ((axl1[i]==bxl1[i])
      &&(axl2[i]==bxl2[i]))
      vert_l[i]=-vert_l[i];
      if ((check_nap[i]==1)
      &&(bxl1[i]!=0)
      &&(bxl2[i]!=0))
      {
	if (x1/8<xl1[i]/8)
	{
	  naprav_l[i]=-2;
	}
	if (x1/8>=xl1[i]/8)
	{
	  naprav_l[i]=2;
	}
	check_nap[i]=0;
      }
/*⮫ 客*/
      for (j=0; j<loxov; j++)
      {
	if ((i!=j)
	&&(abs(xl1[i]-xl1[j])<8)
	&&(abs(xl2[i]-xl2[j])<8))
	{
	  if (abs(xl2[i]-xl2[j])!=0)
	  {
	    vert_l[i]=abs(vert_l[i])*abs(xl2[i]-xl2[j])/(xl2[i]-xl2[j]);
	    vert_l[j]=abs(vert_l[j])*abs(xl2[j]-xl2[i])/(xl2[j]-xl2[i]);
	  }
	  if (abs(xl1[i]-xl1[j])!=0)
	  {
	    naprav_l[i]=abs(naprav_l[i])*abs(xl1[i]-xl1[j])/(xl1[i]-xl1[j]);
	    naprav_l[j]=abs(naprav_l[j])*abs(xl1[j]-xl1[i])/(xl1[j]-xl1[i]);
	  }
	}
      }
/*    */
      if ((xl1[i]/8==(xl1[i]+7)/8)
      &&((x2/8-xl2[i]/8)>abs(xl1[i]/8-x1/8))
      &&(k[(xl1[i])/8][(xl2[i]+8)/8]<=1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+8)/8]<=1)
      &&(kanat_l[i]==1))
      {
	kanat_l[i]=0;
	padla_l[i]=1;
	vert_l[i]=2;
	Beg_Clear_lox(i);
	telo_l[i]=5;
	xl2[i]=xl2[i]+vert_l[i];
	Beg_Runer_lox(i);
	check_nap[i]=1;
      }
/* 砫  த  */
      if ((((int)((xl2[i])/8)==(int)((xl2[i]+7)/8))
      &&(k[(xl1[i])/8][(xl2[i])/8]==1)
      &&(k[(xl1[i])/8][(xl2[i]+7)/8]==1))
      ||(((int)((xl2[i])/8)==(int)((xl2[i]+7)/8))
      &&(k[(xl1[i]+7)/8][(xl2[i])/8]==1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+7)/8]==1)))
      {
	if (kanat_l[i]==0)
	{
	  kanat_l[i]=1;
	  Beg_Clear_lox(i);
	  telo_l[i]=5;
	  xl1[i]=xl1[i]+naprav_l[i];
	  Beg_Runer_lox(i);
	}
	else
	{
	  Beg_Clear_lox(i);
	  xl1[i]=xl1[i]+naprav_l[i];
	  Beg_Runer_lox(i);
	}
      }
/* ⥭ ᫥  ࠢ */
      index1=(xl1[i]-2+abs(abs(naprav_l[i])+naprav_l[i])*10/4)/8;
      if ((k[index1][xl2[i]/8]<5)
	&&(k[index1][(xl2[i]+7)/8]<5))
      {
	if ((bashka_l[i]==0)
	&&(yama_l[i]==0)
	&&(padla_l[i]!=1)
	&&(lest_l[i]!=1)
	&&(kanat_l[i]!=1))
	{
	  Beg_Clear_lox(i);
	  xl1[i]=xl1[i]+naprav_l[i];
	  Beg_Runer_lox(i);
	}
      }
      else
      {
	if ((lest_l[i]!=1)&&(bashka_l[i]==0))
	if (naprav_l[i]==2) naprav_l[i]=-2; else naprav_l[i]=2;
      }

/* ⥭    ᭨  "ᢥ" ﬠ */
      if ((k[xl1[i]/8-1][xl2[i]/8]>=5)
	&&(k[xl1[i]/8-1][(xl2[i]+5)/8]>=5)
	&&(k[(xl1[i]+7)/8-1][xl2[i]/8]>=5)
	&&(k[(xl1[i]+7)/8-1][(xl2[i]+5)/8]>=5)
	&&(k[xl1[i]/8+1][xl2[i]/8]>=5)
	&&(k[xl1[i]/8+1][(xl2[i]+5)/8]>=5)
	&&(k[(xl1[i]+7)/8+1][xl2[i]/8]>=5)
	&&(k[(xl1[i]+7)/8+1][(xl2[i]+5)/8]>=5))
      {
	tupik_l[i]=1;
	if ((k[xl1[i]/8][xl2[i]/8+1]>=5)
	  &&(k[xl1[i]/8][(xl2[i]+7)/8+1]>=5)
	  &&(k[(xl1[i]+7)/8][xl2[i]/8+1]>=5)
	  &&(k[(xl1[i]+7)/8][(xl2[i]+7)/8+1]>=5)
	  &&(k[xl1[i]/8][xl2[i]/8]!=2)
	  &&(k[xl1[i]/8][(xl2[i]+7)/8]!=2)
	  &&(k[(xl1[i]+7)/8][xl2[i]/8]!=2)
	  &&(k[(xl1[i]+7)/8][(xl2[i]+7)/8]!=2))
	{
	  Beg_Clear_lox(i);
	  Beg_Runer_lox(i);
	}
      }
      else
	tupik_l[i]=0;

/*⭨*/
      if ((((k[(xl1[i]+1)/8][(xl2[i]+7+abs(abs(vert_l[i])+vert_l[i])/4)/8]==2)
	  &&(k[(xl1[i]+6)/8][(xl2[i]+7+abs(abs(vert_l[i])+vert_l[i])/4)/8]==2))
	 ||((k[(xl1[i]+1)/8][(xl2[i])/8]==2)
	  &&(k[(xl1[i]+6)/8][(xl2[i])/8]==2)))
	  &&(k[(xl1[i]+1)/8][(xl2[i]-1+abs(abs(vert_l[i])+vert_l[i])*9/4)/8]<5)
	  &&(bashka_l[i]!=1)&&(xl1[i]/8==(xl1[i]+7)/8))
      {
	if ((lest_l[i]==0)&&((xl2[i])/8==x2/8))
	{;}else
	{
	  if (lest_l[i]==0) check_nap[i]=1;
	  lest_l[i]=1;
	  Beg_Clear_lox(i);
	  xl2[i]=xl2[i]+vert_l[i];
	  Beg_Runer_lox(i);
	}
      }
/* ஢ઠ  ⭨ */
      index1=xl1[i]/8-1+abs(abs(naprav_l[i])+naprav_l[i])*2/4;
      index2=(xl2[i]+6+abs(abs(vert_l[i])+vert_l[i])/4)/8;
      if (
      ((lest_l[i]==1)&&
      ((((xl2[i])/8==x2/8)
      &&(k[index1][(xl2[i]+8)/8]>=5)
      &&(k[index1][xl2[i]/8]==0)
      &&(k[index1][(xl2[i]+7)/8]==0))
      ||(((xl2[i])/8==x2/8)
      &&(k[index1][xl2[i]/8]==1)
      &&(k[index1][(xl2[i]+7)/8]==1))
      ||(k[(xl1[i]+1)/8][(xl2[i]-1+abs(abs(vert_l[i])+vert_l[i])*9/4)/8]>=5)
      ||((k[(xl1[i]+1)/8][index2]!=2)
      &&(k[(xl1[i]+6)/8][index2]!=2)))
      )
      &&(xl2[i]/8==(xl2[i]+7)/8)
      &&(tupik_l[i]==0)
      )
      {
	lest_l[i]=0;
	check_nap[i]=1;
      }
/* 稫  */
      if ((k[(xl1[i])/8][(xl2[i]+7)/8]!=1)
      &&(k[(xl1[i]+7)/8][(xl2[i]+7)/8]!=1)
      &&(kanat_l[i]==1))
      {
	kanat_l[i]=0;
	Beg_Clear_lox(i);
	telo_l[i]=0;
	Beg_Runer_lox(i);
      }
    }
/* 﫨  ! */
    if ((abs(xl1[i]-x1)<8)
    &&(abs(xl2[i]-x2)<8))
    {
      lives=lives-1;
      loop=FAIL;
    }
  }
}

/*--------------------------------------------------------------------------*/
void Start()
{
  int i1=0;
  int i2=0;
  int i;
  loop=0;
  naprav=2;
  vert=0;
  telo=0;
  keypush=0;
  padla=0;
  lest=0;
  kanat=0;
  oldx=0;
  oldy=0;
  oldobj=0;
  for (i=0;i<15;i++)
  {
    yama[i]=0;
    yam1[i]=0;
    yam2[i]=0;
  }
  for (i=0;i<8;i++)
  {
    vert_l[i]=0;
    telo_l[i]=0;
    yama_l[i]=0;
    yashik_l[i]=0;
    padla_l[i]=0;
    lest_l[i]=0;
    bashka_l[i]=0;
    kanat_l[i]=0;
    tupik_l[i]=0;
    check_nap[i]=1;
    axl1[i]=0;
    axl2[i]=0;
    bxl1[i]=0;
    bxl2[i]=0;
    xl1[i]=0;
    xl2[i]=0;
    xl3[i]=0;
    naprav_l[i]=0;
  }
  while (i1<22)
  {
    i2=0;
    while (i2<22)
    {
      k[i1][i2]=0;
      i2=i2+1;
    }
    i1=i1+1;
  }
  if (level>MAXLEVEL)
  {
    level=1;
  }
  What_map();
  i1=0;
  while (i1<21)
  {
    k[i1][0]=6;
    k[0][i1]=6;
    k[i1][21]=6;
    k[21][i1]=6;
    i1=i1+1;
  }
  LibClrDisp();
  DrawMap();
  Beg_Clear();
  for (i1=0; i1<8; i1++)
  Beg_Clear_lox(i1);
  PrintXY("Lives",   10,0);
  PrintInt(lives,    32,0);
  PrintXY("Level",   60,0);
  PrintInt(level,    83,0);
  PrintXY("Boxes",  110,0);
  PrintInt(yashikov,136,0);
  LibPutDisp();
}

/*--------------------------------------------------------------------------*/
void What_map()
{
  switch(level)
  {
    case 1:
    Draw_array(map1);
    break;
    case 2:
    Draw_array(map2);
    break;
    case 3:
    Draw_array(map3);
    break;
    case 4:
    Draw_array(map4);
    break;
    case 5:
    Draw_array(map5);
    break;
    case 6:
    Draw_array(map6);
    break;
    case 7:
    Draw_array(map7);
    break;
    case 8:
    Draw_array(map8);
    break;
    case 9:
    Draw_array(map9);
    break;
    case 10:
    Draw_array(map10);
    break;
    case 11:
    Draw_array(map11);
    break;
    case 12:
    Draw_array(map12);
    break;
    case 13:
    Draw_array(map13);
    break;
    case 14:
    Draw_array(map14);
    break;
    case 15:
    Draw_array(map15);
    break;
    case 16:
    Draw_array(map16);
    break;
    case 17:
    Draw_array(map17);
    break;
    case 18:
    Draw_array(map18);
    break;
    case 19:
    Draw_array(map19);
    break;
    case 20:
    Draw_array(map20);
    break;
    case 21:
    Draw_array(map21);
    break;
    case 22:
    Draw_array(map22);
    break;
    case 23:
    Draw_array(map23);
    break;
    case 24:
    Draw_array(map24);
    break;
    case 25:
    Draw_array(map25);
    break;
    case 26:
    Draw_array(map26);
    break;
    case 27:
    Draw_array(map27);
    break;
    case 28:
    Draw_array(map28);
    break;
    case 29:
    Draw_array(map29);
    break;
    case 30:
    Draw_array(map30);
    break;
    case 31:
    Draw_array(map31);
    break;
    case 32:
    Draw_array(map32);
    break;
    case 33:
    Draw_array(map33);
    break;
    case 34:
    Draw_array(map34);
    break;
    case 35:
    Draw_array(map35);
    break;
    case 36:
    Draw_array(map36);
    break;
    case 37:
    Draw_array(map37);
    break;
    case 38:
    Draw_array(map38);
    break;
    case 39:
    Draw_array(map39);
    break;
    case 40:
    Draw_array(map40);
    break;
    case 41:
    Draw_array(map41);
    break;
    case 42:
    Draw_array(map42);
    break;
    case 43:
    Draw_array(map43);
    break;
    case 44:
    Draw_array(map44);
    break;
    case 45:
    Draw_array(map45);
    break;
    case 46:
    Draw_array(map46);
    break;
    case 47:
    Draw_array(map47);
    break;
    case 48:
    Draw_array(map48);
    break;
    case 49:
    Draw_array(map49);
    break;
    case 50:
    Draw_array(map50);
    break;
    case 51:
    Draw_array(map51);
    break;
    case 52:
    Draw_array(map52);
    break;
    case 53:
    Draw_array(map53);
    break;
    case 54:
    Draw_array(map54);
    break;
    case 55:
    Draw_array(map55);
    break;
    case 56:
    Draw_array(map56);
    break;
    case 57:
    Draw_array(map57);
    break;
    case 58:
    Draw_array(map58);
    break;
    case 59:
    Draw_array(map59);
    break;
    case 60:
    Draw_array(map60);
    break;
    case 61:
    Draw_array(map61);
    break;
    case 62:
    Draw_array(map62);
    break;
    case 63:
    Draw_array(map63);
    break;
    case 64:
    Draw_array(map64);
    break;
    case 65:
    Draw_array(map65);
    break;
    case 66:
    Draw_array(map66);
    break;
    case 67:
    Draw_array(map67);
    break;
    case 68:
    Draw_array(map68);
    break;
    case 69:
    Draw_array(map69);
    break;
    case 70:
    Draw_array(map70);
    break;
    case 71:
    Draw_array(map71);
    break;
    case 72:
    Draw_array(map72);
    break;
    case 73:
    Draw_array(map73);
    break;
    case 74:
    Draw_array(map74);
    break;
    case 75:
    Draw_array(map75);
    break;
    case 76:
    Draw_array(map76);
    break;
    case 77:
    Draw_array(map77);
    break;
    case 78:
    Draw_array(map78);
    break;
    case 79:
    Draw_array(map79);
    break;
    case 80:
    Draw_array(map80);
    break;
  }
}

/*--------------------------------------------------------------------------*/
void DrawMap()
{
  int i1=1;
  int i2=1;
  yashikov=0;
  loxov=0;
  while (i1<21)
  {
    i2=1;
    while (i2<21)
    {
      if (k[i1][i2]==6)
      {
	Draw_gdsbox(i1*8-8,i2*8-8,i1*8+7-8,i2*8+6-8);
      }
      if (k[i1][i2]==-4)
      {
	Draw_gdsbox(i1*8-8,i2*8-8,i1*8+4-8,i2*8+2-8);
	Draw_gdsbox(i1*8+6-8,i2*8-8,i1*8+7-8,i2*8+2-8);
	Draw_gdsbox(i1*8-8,i2*8+4-8,i1*8+1-8,i2*8+6-8);
	Draw_gdsbox(i1*8+3-8,i2*8+4-8,i1*8+7-8,i2*8+6-8);
      }
      if (k[i1][i2]==5)
      {
	Draw_gdsbox(i1*8-8,i2*8-8,i1*8+4-8,i2*8+2-8);
	Draw_gdsbox(i1*8+6-8,i2*8-8,i1*8+7-8,i2*8+2-8);
	Draw_gdsbox(i1*8-8,i2*8+4-8,i1*8+1-8,i2*8+6-8);
	Draw_gdsbox(i1*8+3-8,i2*8+4-8,i1*8+7-8,i2*8+6-8);
      }
      if (k[i1][i2]==2)
      {
	Draw_gdsbox(i1*8+1-8,i2*8-8,i1*8+1-8,i2*8+7-8);
	Draw_gdsbox(i1*8+6-8,i2*8-8,i1*8+6-8,i2*8+7-8);
	Draw_gdsbox(i1*8+2-8,i2*8+1-8,i1*8+5-8,i2*8+1-8);
	Draw_gdsbox(i1*8+2-8,i2*8+5-8,i1*8+5-8,i2*8+5-8);
      }
      if (k[i1][i2]==1)
      {
	Draw_gdsbox(i1*8-8,i2*8-8,i1*8+7-8,i2*8-8);
      }
      if (k[i1][i2]==-2)
      {
	Draw_box(i1,i2);
	yashikov=yashikov+1;
      }
      if (k[i1][i2]==-5)
      {
	xl1[loxov]=i1*8;
	xl2[loxov]=i2*8;
	xl3[loxov]=1;
	naprav_l[loxov]=0;
	loxov=loxov+1;
	k[i1][i2]=0;
      }
      if (k[i1][i2]==-6)
      {
	x1=i1*8;
	x2=i2*8;
	x3=-1;
	k[i1][i2]=0;
      }
      i2=i2+1;
    }
    i1=i1+1;
  }
}

/*--------------------------------------------------------------------------*/
void Beg_Runer()
{
  if (telo<3) telo=telo+1;
  if (telo==3) telo=0;
  if (telo>4) telo=telo+1;
  if (telo==8) telo=5;
  if (naprav>0) x3=1;
  if (naprav<0) x3=-1;
  switch(telo)
  {
    case 0:
    Draw_Runer0(x1,x2,x3, 0);
    break;
    case 1:
    Draw_Runer1(x1,x2,x3, 0);
    break;
    case 2:
    Draw_Runer2(x1,x2,x3, 0);
    break;
    case 4:
    Draw_Runer4(x1,x2,x3, 0);
    break;
    case 5:
    Draw_Runer5(x1,x2,x3, 0);
    break;
    case 6:
    Draw_Runer6(x1,x2,x3, 0);
    break;
    case 7:
    Draw_Runer7(x1,x2,x3, 0);
    break;
  }
  LibPutDisp();
}

/*--------------------------------------------------------------------------*/
void Beg_Clear()
{
  switch(telo)
  {
    case 0:
    Draw_Runer0(x1,x2,x3, 0);
    break;
    case 1:
    Draw_Runer1(x1,x2,x3, 0);
    break;
    case 2:
    Draw_Runer2(x1,x2,x3, 0);
    break;
    case 4:
    Draw_Runer4(x1,x2,x3, 0);
    break;
    case 5:
    Draw_Runer5(x1,x2,x3, 0);
    break;
    case 6:
    Draw_Runer6(x1,x2,x3, 0);
    break;
    case 7:
    Draw_Runer7(x1,x2,x3, 0);
    break;
  }
  LibPutDisp();
}

/*--------------------------------------------------------------------------*/
void Beg_Runer_lox(int b1)
{
  if (telo_l[b1]<3) telo_l[b1]=telo_l[b1]+1;
  if (telo_l[b1]==3) telo_l[b1]=0;
  if (telo_l[b1]>4) telo_l[b1]=telo_l[b1]+1;
  if (telo_l[b1]==8) telo_l[b1]=5;
  if (naprav_l[b1]>0) xl3[b1]=1;
  if (naprav_l[b1]<0) xl3[b1]=-1;
  switch(telo_l[b1])
  {
    case 0:
    Draw_Runer0(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 1:
    Draw_Runer1(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 2:
    Draw_Runer2(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 4:
    Draw_Runer4(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 5:
    Draw_Runer5(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 6:
    Draw_Runer6(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 7:
    Draw_Runer7(xl1[b1],xl2[b1],xl3[b1],1);
    break;
  }
  LibPutDisp();
}

/*--------------------------------------------------------------------------*/
void Beg_Clear_lox(int b1)
{
  switch(telo_l[b1])
  {
    case 0:
    Draw_Runer0(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 1:
    Draw_Runer1(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 2:
    Draw_Runer2(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 4:
    Draw_Runer4(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 5:
    Draw_Runer5(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 6:
    Draw_Runer6(xl1[b1],xl2[b1],xl3[b1],1);
    break;
    case 7:
    Draw_Runer7(xl1[b1],xl2[b1],xl3[b1],1);
    break;
  }
  LibPutDisp();
}

/*--------------------------------------------------------------------------*/
void loadData(){
  FILE_INFO domfinf;
  char filename[10];
  strcpy(filename,DATAFILENAME);
  if (LibSubEntrySave((byte *)filename,&fs_entry)==FALSE)
  LibErrorDisp(FlashStatus);
  LibGetAllEntry((byte *)filename,&fm_entry,&fs_entry);
  domfb.fsb_main_entry_=fm_entry;
  domfb.fsb_sub_entry_=fs_entry;
  domfb.fsb_scrt_info_=0x80;
  domfinf.fp=0xffff;
  domfinf.kind=FILE_KIND_BIN;
  if ((LibFileFindNext(&domfb,&domfinf,0x00)==TRUE) && (LibFileRead(&domfb,&domfinf)==TRUE)) {
    memcpy(&SaveData,&domfb.fbuf.bin.bin_buf,sizeof(SaveData));
  } else {
    LibErrorDisp(FlashStatus);
  }
}

/*--------------------------------------------------------------------------*/
void saveSettings(int x, int y) {
  FILE_INFO domfinf;
  char filename[10];
  strcpy(filename,DATAFILENAME);
  if (LibSubEntrySave((byte *)filename,&fs_entry)==FALSE)
  LibErrorDisp(FlashStatus);
  LibGetAllEntry((byte *)filename,&fm_entry,&fs_entry);
  domfb.fsb_main_entry_=fm_entry;
  domfb.fsb_sub_entry_=fs_entry;
  domfb.fsb_scrt_info_=0x80;
  domfinf.fp=0xffff;
  domfinf.kind=FILE_KIND_BIN;
  if (LibFileFindNext(&domfb,&domfinf,0x00)==FALSE)
  domfinf.fp=0xffff;
  domfinf.kind=FILE_KIND_BIN;
  SaveData.lives=x;
  SaveData.level=y;
  memcpy(&domfb.fbuf.bin.bin_buf,&SaveData,sizeof(SaveData));
  domfb.fbuf.bin.char_num=sizeof(SaveData);
  if (LibFileWrite(&domfb,&domfinf)!=TRUE) {
    LibErrorDisp(FlashStatus);
  }
}

/*--------------------------------------------------------------------------*/
